(document:surround "/std/frame")
(document:insert "/std/functions")

;;; functions

(define (update-layout)
  (let ((data (woo-read-first "/xkb")))
    (layout enumref "/xkb/current_layout"
            value (woo-get-option data 'layout))))

(define (do- action)
    (woo-write "/xkb" action #t  'layout (layout value))
    (update-layout))

(define (do-up) (do- 'up))
(define (do-down) (do- 'down))
(define (do-remove) (do- 'remove))

(define (do-add)
  (and (document:popup "/xkb/avail_layout")
       (update-layout)))

(define (do-apply)
  (woo-write "/xkb"
             'submit #t
             'update #t
             'grp (grp value)
             'model (model value)))

;;; ui

(gridbox columns "0;100"

	 (label text (_ "Layouts:") align "left" colspan 2)
         (document:id layout (listbox colspan 2))

         (hbox align "left"
          (document:id add-button (button (_ "Add") align "left"))
          (document:id remove-button (button (_ "Remove") align "left")))
	 (hbox align "right"
          (document:id up-button (button (_ "Up") align "right"))
          (document:id down-button (button (_ "Down") align "right")))

	 (label colspan 2)

         (label text (_ "Layout switching:") align "right")
         (document:id grp (combobox))

         (label text (_ "Model:") align "right")
         (document:id model (combobox))

         (label colspan 2)

         (spacer)
         (document:id apply-button (button (_ "Apply") align "left")))

;;; logic

(document:root (when loaded
                 (woo-catch/message
                  (thunk
                   (let ((data (woo-read-first "/xkb")))
                     (model enumref "/xkb/avail_model"
                            value (woo-get-option data 'model))
                     (grp enumref "/xkb/avail_grp"
                          value (woo-get-option data 'grp))
                     (layout enumref "/xkb/current_layout"
                             value (woo-get-option data 'layout))
                     (up-button (when clicked (woo-catch/message do-up)))
                     (down-button (when clicked (woo-catch/message do-down)))
                     (add-button (when clicked (woo-catch/message do-add)))
                     (remove-button (when clicked (woo-catch/message do-remove)))
                     (apply-button (when clicked (woo-catch/message do-apply))))))))
